#include <LiquidCrystal_I2C.h>
#include <NTPClient.h>
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>

const char *ssid = "";
const char *password = "";

const long utcOffsetInSeconds = 10800;

const char *ntpServerUrl = "pool.ntp.org";

String weekDays[7] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

WiFiUDP ntpUDP;
LiquidCrystal_I2C lcd(0x27, 16, 2);
NTPClient timeClient(ntpUDP, ntpServerUrl, utcOffsetInSeconds);

void lcdClockDate();

void setup()
{
    lcd.init();
    lcd.backlight();
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED)
    {
        delay(500);
        lcd.setCursor(0, 0);
        lcd.print("Connecting to");
        int startPos = (16 - String(ssid).length()) / 2;
        lcd.setCursor(startPos, 1);
        lcd.print(ssid);
    }
    lcd.clear();
    timeClient.begin();
}

void loop()
{
    timeClient.update();
    lcdClockDate();
    delay(2000);
}
void lcdClockDate()
{
    time_t epochTime = timeClient.getEpochTime();
    String formattedTime = timeClient.getFormattedTime().substring(0, 5);
    String weekDay = weekDays[timeClient.getDay()];
    struct tm *ptm = gmtime((time_t *)&epochTime);
    int monthDay = ptm->tm_mday;
    String currentMonth = (ptm->tm_mon + 1) < 10 ? "0" + String(ptm->tm_mon + 1) : String(ptm->tm_mon + 1);
    int currentYear = ptm->tm_year - 100;
    String CurrentDate = String(monthDay) + "/" + String(currentMonth) + "/" + String(currentYear);
    lcd.setCursor(0, 0);
    lcd.print(CurrentDate);
    lcd.setCursor(11, 0);
    lcd.print(formattedTime);
    lcd.setCursor(0, 1);
    lcd.print("                ");
    int startPos = (16 - weekDay.length()) / 2;
    lcd.setCursor(startPos, 1);
    lcd.print(weekDay);
}
